MCDB = MCDB or {
x = 0,
y = 0,
relPt = "CENTER",
enableMouse = true,
hide = false,
hideOOC = false,
scale = 1,
hideNoCircles = false,
soundEffectPlay = false,
soundEffectFile = "Sound\\Spells\\mage_dragons_breath.ogg",
soundEffectTime = 2

};

local defaults = {
x = 0,
y = 0,
relPt = "CENTER",
enableMouse = true,
hide = false,
hideOOC = false,
hideNoCircles = false,
scale = 1,
soundEffectPlay = false,
soundEffectFile = "Sound\\Spells\\mage_dragons_breath.ogg",
soundEffectTime = 2
};


----------------------------------------------
-- Makeshift Constants, don't change them
----------------------------------------------

local backdrop = {
	bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
	edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
	edgeSize = 16,
	insets = {left = 4, right = 4, top = 4, bottom = 4,}
};
local borderless= {
	bgFile = "interface\\buttons\\white8x8",
}
local optionsBackdrop = {
	bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
	edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
	tile = true,
	tileSize = 16,
	edgeSize = 16,
	insets = {left = 4, right = 4, top = 4, bottom = 4}
}	

local UPDATE_INTERVAL = 0.5;
local MC = "|cffe1a500Magic|cff69ccf0Cricles|r";

local playerGUID = UnitGUID("player");
local _, playerClass, _ = UnitClass("player");

----------------------------------------------
-- Just some variables
----------------------------------------------

local ropKnown = false;
local RUNE_OF_POWER_DURATION_SECONDS = 10;

----------------------------------------------
-- Main Frame
----------------------------------------------

local main = CreateFrame("Frame","MagicCirclesMainFrame",UIParent);

main.getLoc = function()
	local point, relativeTo, relPt, xOff, yOff = main:GetPoint();
	MCDB.x = xOff;
	MCDB.y = yOff;
	MCDB.relPt = relPt;
end

----------------------------------------------
-- Create Timers and their functions function
----------------------------------------------

local numTimers = 0;
main.createTimer = function()
	local f = CreateFrame("StatusBar",nil,main);
	f:SetSize(80,20);
	f:SetPoint("TOP",main,0,-2);
	f:SetStatusBarTexture("interface\\addons\\magiccircles\\textures\\minimalist");
	f:SetStatusBarColor(0.41, 0.80, 0.94, 1.00);
	f:SetMinMaxValues(0,RUNE_OF_POWER_DURATION_SECONDS);
	f.text = f:CreateFontString(nil,"OVERLAY","ChatFontSmall");
	f.text:SetPoint("CENTER",f);
	f.text:SetText("0.0s");
	
	f.timeLeft = 0;
	f.clearTimer = function()
		f.timeLeft = 0;
		f.text:SetText("No RoP");
		f:SetValue(RUNE_OF_POWER_DURATION_SECONDS);
		f:SetStatusBarColor(0.43, 0.43, 0.43, 1.00);
		main.visibility();
	end
	f.update = function()
		if (f.timeLeft>0) then
			f.timeLeft = f.timeLeft - UPDATE_INTERVAL;
			f:SetValue(math.ceil(f.timeLeft));
			f.text:SetFormattedText("%.1fs",f.timeLeft);
			if (f.timeLeft==MCDB.soundEffectTime and MCDB.soundEffectPlay==true) then
				PlaySoundFile(MCDB.soundEffectFile);
			end
			if (f.timeLeft>5) then -- Greater than 30 seconds, bar is blue
				f:SetStatusBarColor(0.41, 0.80, 0.94, 1.00);
			elseif (f.timeLeft<5.5 and f.timeLeft>2) then -- 30 - 15.5 seconds, bar is orange
				f:SetStatusBarColor(0.96, 0.75, 0.44, 1.00);
			elseif (f.timeLeft<2.5) then -- 15 seconds left, bar is red
				f:SetStatusBarColor(1.00, 0.17, 0.17, 1.00);
			end
		elseif (f.timeLeft<=0) then
			f.clearTimer();
		end
	end
	
	numTimers = numTimers + 1;
	
	return f;
end

main:SetSize(84,24);
main:SetPoint("CENTER",UIParent);
main:SetBackdrop(borderless);
main:SetBackdropColor(0,0,0,0.5);
main:SetMovable(true);
main:EnableMouse(true);
main:SetScript("OnMouseDown",function(s,b)
	if (b=="LeftButton") then
		s:StartMoving();
	end
end);
main:SetScript("OnMouseUp",function(s)
	s:StopMovingOrSizing();
	s.getLoc();
end);

local title = main:CreateFontString(nil, "OVERLAY", "ChatFontSmall");
title:SetPoint("BOTTOM",main,"TOP");
title:SetText(MC);

main.timer1 = main.createTimer();
--main.timer2 = main.createTimer();

----------------------------------------------
-- Options Frame
----------------------------------------------

main.options = CreateFrame("Frame","MagicCirclesOptionsFrame",UIParent);
main.options:SetBackdrop(optionsBackdrop);
main.options:SetBackdropColor(0.1,0.1,0.1,0.9);
main.options:SetSize(220,350);
main.options:SetPoint("CENTER", UIParent);
main.options:EnableMouse(true);
main.options:SetMovable(true);
main.options:SetScript("OnMouseDown",function(self,button) if (button=="LeftButton") then self:StartMoving() end end);
main.options:SetScript("OnMouseUp",function(self) self:StopMovingOrSizing() end);
main.options:Hide();
local header = main.options:CreateTexture("ARTWORK");
header:SetPoint("CENTER", main.options, "TOP", 0, -16);
header:SetTexture("interface\\dialogframe\\ui-dialogbox-header");
header:SetSize(256,64);
local headerText = main.options:CreateFontString(nil,"OVERLAY","ChatFontSmall");
headerText:SetPoint("CENTER", header, "TOP", 0, -20);
headerText:SetFormattedText("%s Options",MC);

main.options.content = CreateFrame("Frame",nil,main.options);
main.options.content:SetBackdrop(backdrop);
main.options.content:SetBackdropColor(0.1,0.1,0.1,0.9);
main.options.content:SetBackdropBorderColor(1,1,1,0.9);
main.options.content:SetPoint("TOP", main.options, 0, -20);
main.options.content:SetSize(main.options:GetWidth()-20, main.options:GetHeight()-55);

-- Size and Position

local textSizePosition = main.options.content:CreateFontString(nil, "OVERLAY", "ChatFontSmall");
textSizePosition:SetPoint("TOPLEFT", main.options.content, 10, -10);
textSizePosition:SetText("|cffe1a500Size and Position");

local checkEnable = CreateFrame("CheckButton", nil, main.options.content, "UICheckButtonTemplate");
checkEnable:SetPoint("TOPLEFT",textSizePosition, "BOTTOMLEFT", 5, -5);
checkEnable:SetSize(20,20);
checkEnable:SetScript("OnClick", function(self) 
	MCDB.hide = not MCDB.hide;
	main.visibility();
end);
checkEnable:SetScript("OnShow", function(self) self:SetChecked(MCDB.hide) end);
checkEnable.text = checkEnable:CreateFontString(nil, "OVERLAY", "ChatFontSmall");
checkEnable.text:SetPoint("LEFT",checkEnable,"RIGHT");
checkEnable.text:SetText("Enable MagicCircles");

local checkLock = CreateFrame("CheckButton", nil, main.options.content, "UICheckButtonTemplate");
checkLock:SetPoint("TOP", checkEnable, "BOTTOM", 0, -5);
checkLock:SetSize(20,20);
checkLock:SetScript("OnClick", function(self)
	MCDB.enableMouse = not MCDB.enableMouse;
	main:EnableMouse(MCDB.enableMouse);
	main.visibility();
end);
checkLock.text = checkLock:CreateFontString(nil, "OVERLAY", "ChatFontSmall");
checkLock.text:SetPoint("LEFT",checkLock,"RIGHT");
checkLock.text:SetText("Lock MagicCircles");

local sliderScale = CreateFrame("Slider", "MagicCirclesScaleSlider", main.options.content, "OptionsSliderTemplate");
sliderScale:SetPoint("TOPLEFT", checkLock, "BOTTOMLEFT", 5, -20);
sliderScale:SetSize(165, 16);
sliderScale:SetMinMaxValues(0.5, 2);
sliderScale:SetValue(1);
sliderScale:SetValueStep(0.01);
sliderScale:SetOrientation("HORIZONTAL");
_G[sliderScale:GetName().."Low"]:SetText("50%");
_G[sliderScale:GetName().."High"]:SetText("200%");
sliderScale.text = sliderScale:CreateFontString(nil, "OVERLAY", "ChatFontSmall");
sliderScale.text:SetPoint("BOTTOMLEFT", sliderScale, "TOPLEFT", -3, 5);
sliderScale.text:SetFormattedText("Scale %d%%",MCDB.scale*100);
sliderScale:SetScript("OnValueChanged", function(self)
	if (self == nil) then return end;
	sliderValue = self:GetValue();
	self.text:SetFormattedText("Scale: %d%%",sliderValue*100);
	main:SetScale(sliderValue);
	MCDB.scale = sliderValue;
end);

-- Hide MagicCirlces if:

local textHideIf = main.options.content:CreateFontString(nil, "OVERLAY", "ChatFontSmall");
textHideIf:SetPoint("TOPLEFT", sliderScale, "BOTTOMLEFT", -10, -15);
textHideIf:SetText("|cffe1a500Hide MagicCircles if:");

local checkOOC = CreateFrame("CheckButton", nil, main.options.content, "UICheckButtonTemplate");
checkOOC:SetPoint("TOPLEFT", textHideIf, "BOTTOMLEFT", 5, -5);
checkOOC:SetSize(20,20);
checkOOC:SetScript("OnClick", function(self) 
	MCDB.hideOOC = not MCDB.hideOOC;
	main.visibility();
end);
checkOOC.text = checkOOC:CreateFontString(nil, "OVERLAY", "ChatFontSmall");
checkOOC.text:SetPoint("LEFT", checkOOC, "RIGHT");
checkOOC.text:SetText("Out of Combat");

local checkNoCircles = CreateFrame("CheckButton", nil, main.options.content, "UICheckButtonTemplate");
checkNoCircles:SetPoint("TOP", checkOOC, "BOTTOM", 0, -5);
checkNoCircles:SetSize(20,20);
checkNoCircles:SetScript("OnClick", function(self)
	MCDB.hideNoCircles = not MCDB.hideNoCircles;
	main.visibility();
end);
checkNoCircles.text = checkNoCircles:CreateFontString(nil, "OVERLAY", "ChatFontSmall");
checkNoCircles.text:SetPoint("LEFT",checkNoCircles,"RIGHT");
checkNoCircles.text:SetText("No Runes of Power active");

-- Sound effects

local textSound = main.options.content:CreateFontString(nil, "OVERLAY", "ChatFontSmall");
textSound:SetPoint("TOPLEFT", checkNoCircles, "BOTTOMLEFT", -5, -5);
textSound:SetText("|cffe1a500Sound Effects");

local checkEnableSound = CreateFrame("CheckButton", nil, main.options.content, "UICheckButtonTemplate");
checkEnableSound:SetPoint("TOPLEFT", textSound, "BOTTOMLEFT", 5, -5);
checkEnableSound:SetSize(20,20);
checkEnableSound:SetScript("OnClick", function(self)
	MCDB.soundEffectPlay = not MCDB.soundEffectPlay;
end);
checkEnableSound:SetScript("OnEnter", function(self)
	GameTooltip:SetOwner(self, "ANCHOR_BOTTOMLEFT");
	GameTooltip:ClearLines();
	GameTooltip:SetText("Play a sound effect warning\nat a chosen time remaining.\n\n|cffff0000Note|r:\nRequires game sound effects enabled");
	GameTooltip:Show();
end);
checkEnableSound:SetScript("OnLeave", function(self)
	GameTooltip:Hide();
end);
checkEnableSound.text = checkEnableSound:CreateFontString(nil, "OVERLAY", "ChatFontSmall");
checkEnableSound.text:SetPoint("LEFT", checkEnableSound, "RIGHT");
checkEnableSound.text:SetText("Enable sound effect warning");

local textTimeLeft = main.options.content:CreateFontString(nil, "OVERLAY", "ChatFontSmall");
textTimeLeft:SetPoint("TOPLEFT", checkEnableSound, "BOTTOMLEFT", 0, -5);
textTimeLeft:SetText("Play warning with       seconds left");

local editTimeLeft = CreateFrame("EditBox", nil, main.options.content);
editTimeLeft:SetSize(30,10);
editTimeLeft:SetPoint("LEFT", textTimeLeft, 90, -1);
editTimeLeft:IsMultiLine(false);
editTimeLeft:SetAutoFocus(false);
editTimeLeft:SetText("30");
editTimeLeft:SetFontObject("OptionsFontSmall");
editTimeLeft:SetMaxBytes(3);
editTimeLeft:SetScript("OnEnterPressed", function(self)
	self:ClearFocus();
	local editValue = self:GetNumber();
	if (editValue==nil or editValue<0 or editValue>60) then
		print(string.format("%s: Please enter a value between 0 and 60 seconds.", MC));
		self:SetText(MCDB.soundEffectTime);
	else
		MCDB.soundEffectTime = editValue;
	end
end);


main.options:SetScript("OnShow", function(self)
	-- Size and Position
	checkEnable:SetChecked(not MCDB.hide);
	checkLock:SetChecked(not MCDB.enableMouse);
	sliderScale.text:SetFormattedText("Scale: %d%%",MCDB.scale*100);
	sliderScale:SetValue(MCDB.scale);
	
	-- Hide MagicCircles if:
	checkOOC:SetChecked(MCDB.hideOOC);
	checkNoCircles:SetChecked(MCDB.hideNoCircles);
	
	-- Sound effects
	checkEnableSound:SetChecked(MCDB.soundEffectPlay);
	editTimeLeft:SetText(MCDB.soundEffectTime);
end);

local closeButton = CreateFrame("BUTTON", nil, main.options, "OptionsButtonTemplate");
closeButton:SetPoint("BOTTOMRIGHT", main.options, -10, 10);
closeButton:SetScript("OnClick", function(self) main.options:Hide() end);
closeButton:SetSize(65,20);
closeButton:SetText("Close");

local footer = CreateFrame("Frame", nil, main.options);
footer:SetPoint("BOTTOMLEFT", main.options, 10, 10);
footer:SetBackdrop(backdrop);
footer:SetBackdropColor(0.1, 0.1, 0.1, 0.9);
footer:SetBackdropBorderColor(1, 1, 1, 0.9);
footer:SetSize(main.options:GetWidth()-90,22);
footer.text = footer:CreateFontString(nil, "OVERLAY", "ChatFontSmall");
footer.text:SetPoint("LEFT", footer, 10, 0);
footer.text:SetFormattedText("|cffe1a500Version |r%s",GetAddOnMetadata("MagicCircles","Version"));

----------------------------------------------
-- Visibility function
----------------------------------------------

main.visibility = function()
	main:Show();
	
	if (playerClass ~= "MAGE") then
		main:Hide();
		main.event:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	end
	
	if (ropKnown==false) then
		main:Hide();
	end
	
	if (MCDB.enableMouse==true) then
		title:SetAlpha(1); 
	elseif (MCDB.enableMouse==false) then
		title:SetAlpha(0);
	end
	
	if (MCDB.hide==true) then
		main:Hide();
	end
	
	if (MCDB.hideOOC==true) then
		if (not UnitAffectingCombat("player")) then
			main:Hide();
		end 
	end
	
	if (MCDB.hideNoCircles==true) then
		--if (main.timer1.timeLeft==0 and main.timer2.timeLeft==0) then
		if (main.timer1.timeLeft==0) then
			main:Hide();
		end
	end
	
end

----------------------------------------------
-- Slash command
----------------------------------------------

SLASH_MAGICCIRCLES1 = '/mc';
SLASH_MAGICCIRCLES2 = '/magiccircles';
SLASH_MAGICCIRCLES3 = '/magicc';
SLASH_MAGICCIRCLES4 = '/mcircles';
function SlashCmdList.MAGICCIRCLES(msg, edit)	
	if (msg=="config") then
		main.options:Show();
	else 
		MCDB.enableMouse = not MCDB.enableMouse;
		main:EnableMouse(MCDB.enableMouse);
		if (MCDB.enableMouse==true) then
			print(string.format("%s unlocked. Type /mc to lock. Use command /mc config for more options.",MC));
		elseif (MCDB.enableMouse==false) then
			print(string.format("%s locked. Type /mc to unlock. Use command /mc config for more options.",MC));
		end		
		checkLock:SetChecked(not MCDB.enableMouse);
		main.visibility();
	end
end

----------------------------------------------
-- Update and Event frames
----------------------------------------------

main.update = CreateFrame("Frame");
main.event = CreateFrame("Frame");

local update = main.update;
local event = main.event;

event:RegisterEvent("ADDON_LOADED");
event:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
event:RegisterEvent("PLAYER_ENTERING_WORLD");
event:RegisterEvent("PLAYER_TALENT_UPDATE");
event:SetScript("OnEvent",function(s,event,a1,a2,a3,a4,...)
	if (event=="ADDON_LOADED" and a1=="MagicCircles") then
		for k,v in pairs(defaults) do
			if (MCDB[k] == nil) then
				MCDB[k] = defaults[k]
			end 
		end
		
		main:SetPoint(MCDB.relPt,UIParent,MCDB.x,MCDB.y);
		main:SetScale(MCDB.scale);
		main:EnableMouse(MCDB.enableMouse);
		main.visibility();
		
		-- Change .wav file to .ogg for patch
		if (MCDB.soundEffectFile=="Sound\\Spells\\mage_dragons_breath.wav") then
			MCDB.soundEffectFile = "Sound\\Spells\\mage_dragons_breath.ogg"
		end
	elseif (event=="COMBAT_LOG_EVENT_UNFILTERED") then
		if (not playerGUID) then playerGUID = UnitGUID("player"); end		
		local spellID = select(8,...);
		if (a4==playerGUID and a2=="SPELL_SUMMON" and spellID==116011) then
		
			--[[if (main.timer1.timeLeft < main.timer2.timeLeft) then
				main.timer1.timeLeft = 60;
			elseif (main.timer1.timeLeft > main.timer2.timeLeft) then
				main.timer2.timeLeft = 60;
			elseif (main.timer1.timeLeft==0 and main.timer2.timeLeft==0) then
				main.timer1.timeLeft = 60;				
			end]]
			
			main.timer1.timeLeft = RUNE_OF_POWER_DURATION_SECONDS
			
			main.visibility();
			
		end
	elseif (event=="PLAYER_ENTERING_WORLD") then
		main.timer1.clearTimer();
		--main.timer2.clearTimer();
	elseif (event=="PLAYER_TALENT_UPDATE") then
	
		-- Player might learn or unlearn Rune of Power
		local _, _, _, _, selected, _ = GetTalentInfo(17);
		
		ropKnown = selected;
		
		main.visibility();
		
	end
end);

update.e = 0;
update:SetScript("OnUpdate",function(s,elap)
	update.e = update.e + elap;
	if (update.e >= UPDATE_INTERVAL) then
		main.timer1.update();
		--main.timer2.update();
		update.e = 0;
	end	
end);